/*
 *
 * test zarovnavani polozek struktur
 *
 */

#include <stdio.h>

struct test {
    char c1;
    int i;
    char c2;
};

struct test st;

#define OFFSET(st,item) ((unsigned)((char*)&st.item  - (char*)&st))

int main() {

    printf("\nsizeof(st) = %u\n", (unsigned) sizeof(st));
    printf("&st      = %p\n", (void*) &st);
    printf("&st.c1   = %p (%u)\n", (void*) &st.c1,     OFFSET(st,c1));
    printf("&st.i    = %p (%u)\n", (void*) &st.i,      OFFSET(st,i));
    printf("&st.c2   = %p (%u)\n", (void*) &st.c2,     OFFSET(st,c2));
    printf("(&st)+1  = %p (%u)\n", (void*) (&st + 1),  (unsigned) sizeof(st));

    return 0;
}

