
// demo: intmax_t and printf formats (+wide output)

#include <inttypes.h>
#include <wchar.h>

int main(void)
{
    intmax_t i = INTMAX_MAX; // This type always exists.
    wprintf(L"The largest integer value is              %#020" PRIxMAX "\n", i);
    ++i;        // Undefined behaviour (UB)
    wprintf(L"The largest integer value + 1 is          %#020" PRIxMAX "\n", i);

    uintmax_t u = UINTMAX_MAX; // This type always exists.
    wprintf(L"The largest unsigned integer value is     %#020" PRIxMAX "\n", u);
    ++u;        // modular arithmetic
    wprintf(L"The largest unsigned integer value + 1 is %#020" PRIxMAX "\n", u);
}

