
// demonstrate some #pragma usage (for GCC only)

#include <stdio.h>

#pragma GCC optimize ("-O2")
#pragma GCC diagnostic warning "-Wall"

#pragma GCC diagnostic push     // save setting

#if 1
# pragma GCC diagnostic ignored "-Wformat"      // ignore warning
#else
# pragma GCC diagnostic error "-Wformat"
# pragma message "Warning turned to error in " __FILE__
#endif

int f(int i) {
    printf("%ld\n",i);  // intentional error in format string
#if 0
    return i;           // warning: missing return
#endif
}

#pragma GCC diagnostic pop      // restore

int main(void) {
    f(10);
}

