/*
 *  rdtsc.h
 *  -----------------------------------------------------------------
 *
 *  function for reading Pentium+, K6, ... 64 bit timer
 *  provides high resolution time
 *  only for GNU C/C++
 *  Warning: works in 32bit environment only
 *  
 */

extern __inline long long rdtsc()
{
    register long long edxeax;
    __asm __volatile__ ( "rdtsc" : "=A" (edxeax) );
    return edxeax;
}


