/*
 *  rdtsc.h
 *  -----------------------------------------------------------------
 *  function for reading 64 bit timer (Pentium, K6, etc.)
 *  for GNU C/C++ only
 *  WARNING: obsolete, use compiler intrinsic __builtin_ia32_rdtsc
 */
#ifndef __GNUC__
#error "use GNU C, please"
#endif

// universal x86, x86-64 code:
static __inline__ unsigned long long rdtsc(void)
{
    unsigned a, d;
    __asm volatile ("rdtsc":"=a" (a), "=d"(d)); // compiler-dependent
    return ((unsigned long long) a) | (((unsigned long long) d) << 32);
}

